## copy this folder where you have your ROOT/BAM file
SAMPLEID=NA12878 			## individual's ID
NAME=test		        	## e.g. hiseq_pcrfree_hc_130506
FASTA=/path/to/fasta/			## path to FASTAs
BINSIZE=100			       	## binsize e.g. 100 for high coverage (trio data), 1000 for low coverage (1KG data)
ROOT=/path/to/NA12878.root		## path of (tree) ROOT file from CNVnator
SNP=/path/to/NA12878.snv		## path to SNV file

## after running CNVnator on the BAM and produces a ROOT file, this generates the histogram from the ROOT file using CNVnator and the FASTAs
ln -s $ROOT
cnvnator -root $ROOT -outroot his.$SAMPLEID.$NAME.root -his $BINSIZE -chrom 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 X Y -d $FASTA
cnvnator -root his.$SAMPLEID.$NAME.root -stat $BINSIZE
cnvnator -root his.$SAMPLEID.$NAME.root -eval $BINSIZE > binSize$BINSIZE.log

## prepare addRD file
rd=$(grep "Average RD per bin (1-22) is" binSize$BINSIZE.log | sed 's/Average RD per bin (1-22) is //g'  | awk '{printf("%d\n"),$SAMPLEID + 0.5}')
./print_addRDcpp.sh $ROOT $rd./$BINSIZE
make addRD

## run addRD
ln -s $SNP
./addRD $SNP >& rd.$SAMPLEID.$NAME.cnvnator.log

